# Generated by Django 2.2.7 on 2019-11-05 08:49
from django.db import migrations


def set_email_addresses(apps, schema_editor):
    """
    Iterate through users with names of the form crsid+{CRSID} and set their email address to
    {CRSID}@cam.ac.uk if no other user has that email address.

    We verify that the crsid part is indeed a crsid and avoid setting email addresses if there is
    already a user with that email address. That way we avoid admin-created accounts duplicating
    email addresses.

    """
    User = apps.get_model('auth', 'User')

    # Form a list of crsid users.
    crsid_users = User.objects.filter(username__regex=r'crsid\+[a-z0-9]{3,8}')

    # Set the email field for each user based on crsid
    for u in crsid_users:
        if u.email == '':
            u.email = u.username.split('+')[1] + '@cam.ac.uk'

    # Find any users with non-empty email addresses and form the email addresses into a set.
    existing_emails = {u.email for u in User.objects.exclude(email='')}

    # Filter the list of users to update to those which do not have an email address matching an
    # existing user.
    users_to_update = [u for u in crsid_users if u.email not in existing_emails]

    # Bulk update the email field of the remaining users.
    User.objects.bulk_update(users_to_update, ['email'])


def nop(*args, **kwargs):
    """
    "No-operation" migration to allow migration to be reversed but to take no effect.
    """


class Migration(migrations.Migration):

    dependencies = [
        ('assets', '0012_auto_20180424_1049'),
    ]

    operations = [
        migrations.RunPython(set_email_addresses, nop),
    ]
